/*
*  Module:     SQLiteCpp
*  Delta:      1.0.0 (05/18/2019 11:48:34)
*  Filename:   SQLiteCpp.h
*  $Author: krkim $
*  $Id: SQLiteCpp.h 7761 2025-04-17 06:34:37Z krkim $
*  $Revision: 7761 $
*  $HeadURL:$
*  https://github.com/SRombauts/SQLiteCpp
*/


#pragma once
 
#include <iostream>
#include <sqlite3.h>
#include <vector>
 
static const std::string DIR = "/home/basiclike/VSCode/test/DB/DB_SQLite";
static const std::string QUERY_TABLE_CREATE = "CREATE TABLE t_userinfo (code INTEGER PRIMARY KEY AUTOINCREMENT, id TEXT(12), pw TEXT(18), fname TEXT, lname TEXT, ph TEXT, email TEXT, disabled NUMERIC);";
static const std::string QUERY_TABLE_EXIST = "SELECT name FROM sqlite_master WHERE type='table' AND name='t_userinfo';";
static const std::string QUERY_TABLE_DROP = "DROP TABLE IF EXISTS t_userinfo;";
static const std::string QUERY_TABLE_EXIST_RECORD = "SELECT FilePath FROM t_userinfo WHERE FilePath=? AND CheckSum=? AND Version=?;";
static const std::string QUERY_TABLE_DELETE_RECORD = "DELETE FROM t_userinfo WHERE FilePath=?;";
static const std::string QUERY_TABLE_INSERT_RECORD = "INSERT INTO t_userinfo VALUES(?, ?, ?);";
static const std::string QUERY_TABLE_SELECT_ALL = "SELECT * FROM t_userinfo;";
static const std::string QUERY_DB_CLEAN_UP = "VACUUM;";
static const std::string QUERY_DB_BEGIN___ = "BEGIN;";
static const std::string QUERY_DB_COMMIT__ = "COMMIT;";
static const std::string QUERY_DB_ROLLBACK = "ROLLBACK;";
 
class SQLiteCpp
{
public:
    SQLiteCpp();
    virtual ~SQLiteCpp();
protected:
    sqlite3 *m_db;
 
private:
    bool CreateTable();
    bool DropTable();
    bool IsTableExist();
 
public:
    bool Begin();
    bool Commit();
    bool Rollback();
    bool OpenDB(std::string dbName);
    bool CloseDB();
    std::vector<std::vector<std::string>>  GetAllRecords();
    // bool _insert(std::string dir, std::string checksum, void *binaryData, int size);
    // bool _delete(std::string key);
    bool queryexec(std::string strquery);
    int affected_rows();
    int errcode();
 
};